tables = {}
current_table = {}

function newTable(ttype, name)
	local tbl = tables[name] or {}
	tbl.type = ttype
	tbl.entries = {}
	tbl.name = name
	
	tables[name] = tbl
	return tbl
end

function VOCAB_TABLE(name)
	local tbl = newTable("VOCABULARY", name)
	current_table = tbl
end

function SEQ_TABLE(name)
	local tbl = newTable("SEQUENCE", name)
	current_table = tbl
end

function RAND_TABLE(name)
	local tbl = newTable("RANDOM", name)
	current_table = tbl
end

function ENTRY(target, cap, prob)
	table.insert(current_table.entries, {target=target, capitalize=cap, probability=prob})
end




--include "words.lua"



tables.transVerbPlur={}
tables.adjectivePhrase={}
tables.nounPhrase={}
tables.anySingNoun={}
tables.plurVerbPhrase={}
tables.declaratorySentence={}
tables.address={}
tables.intBooleanPhrase={}


VOCAB_TABLE("comma")
        ENTRY(",", 0, 127)


VOCAB_TABLE("space")
        ENTRY(" ", 0, 127)


VOCAB_TABLE("hyphen")
        ENTRY("-", 0, 127)


VOCAB_TABLE("interPunct")
        ENTRY("? ", 0, 127)
        ENTRY("?! ", 0, 8)
        ENTRY("...", 0, 8)


VOCAB_TABLE("punct")
        ENTRY(". ", 0, 127)
        ENTRY("! ", 0, 32)
        ENTRY("? ", 0, 8)
        ENTRY("...", 0, 8)


VOCAB_TABLE("a")
        ENTRY("a", 0, 127)


VOCAB_TABLE("an")
        ENTRY("an", 0, 127)


VOCAB_TABLE("apostropheS")
        ENTRY("'s", 0, 127)


VOCAB_TABLE("apostrophe")
        ENTRY("'", 0, 127)


VOCAB_TABLE("is")
        ENTRY("is ", 0, 127)
        ENTRY("isn't ", 0, 127)
        ENTRY("is not ", 0, 16)


VOCAB_TABLE("are")
        ENTRY("are ", 0, 127)
        ENTRY("aren't ", 0, 127)
        ENTRY("are not ", 0, 16)


VOCAB_TABLE("am")
        ENTRY(" am ", 0, 127)
        ENTRY(" am not ", 0, 16)
        ENTRY(" ain't ", 0, 32)
        ENTRY("'m ", 0, 127)


VOCAB_TABLE("I")
        ENTRY("I", 0, 127)


VOCAB_TABLE("me")
        ENTRY("me", 0, 127)


VOCAB_TABLE("myself")
        ENTRY("myself", 0, 127)


VOCAB_TABLE("us")
        ENTRY("us", 0, 127)


VOCAB_TABLE("you")
        ENTRY("you ", 0, 127)


VOCAB_TABLE("yourself")
        ENTRY("yourself", 0, 127)


VOCAB_TABLE("whoWhat")
        ENTRY("who ", 0, 127)
        ENTRY("what ", 0, 127)


VOCAB_TABLE("howMany")
        ENTRY("how many ", 0, 127)
        ENTRY("how many more ", 0, 127)
        ENTRY("how many fewer ", 0, 127)


VOCAB_TABLE("which")
        ENTRY("which ", 0, 127)


VOCAB_TABLE("whenWhereWhyHow")
        ENTRY("when ", 0, 127)
        ENTRY("where ", 0, 127)
        ENTRY("why ", 0, 127)
        ENTRY("how ", 0, 127)




--/* Adjective phrase */

SEQ_TABLE("threeAdjectives")
        ENTRY(tables.vocAdjective, 0, 127)
        ENTRY(tables.comma, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocAdjective, 0, 127)
        ENTRY(tables.comma, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocListConjunction, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocAdjective, 0, 127)


SEQ_TABLE("twoAdjectives")
        ENTRY(tables.vocAdjective, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocListConjunction, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocAdjective, 0, 127)


SEQ_TABLE("hyphenatedAdjective")
        ENTRY(tables.adjectivePhrase, 0, 64)
        ENTRY(tables.anySingNoun, 0, 127)
        ENTRY(tables.hyphen, 0, 127)


RAND_TABLE("doAdjectivePhrase")
        ENTRY(tables.vocAdjective, 0, 127)
        ENTRY(tables.twoAdjectives, 0, 16)
        ENTRY(tables.threeAdjectives, 0, 8)


SEQ_TABLE("adjectivePhraseSpace")
        ENTRY(tables.doAdjectivePhrase, 0, 127)
        ENTRY(tables.space, 0, 127)

        
RAND_TABLE("adjectivePhrase")
        ENTRY(tables.adjectivePhraseSpace, 0, 127)
        ENTRY(tables.hyphenatedAdjective, 0, 16)




--/* Plural noun phrase */

RAND_TABLE("anyPlurNoun")
        ENTRY(tables.vocPlurNounNodeterm, 0, 127)
        ENTRY(tables.vocPlurPropNoun, 0, 32)


SEQ_TABLE("numDeterm012")
        ENTRY(tables.vocNumDeterm0, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocNumDeterm1, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocNumDeterm2, 0 ,127)


SEQ_TABLE("numDeterm12")
        ENTRY(tables.vocNumDeterm1, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocNumDeterm2, 0, 127)


SEQ_TABLE("numDeterm01")
        ENTRY(tables.vocNumDeterm0, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocNumDeterm1, 0, 127)


RAND_TABLE("plurNumDeterm")
        ENTRY(tables.vocNumDeterm1, 0, 127)
        ENTRY(tables.numDeterm01, 0, 64)
        ENTRY(tables.numDeterm12, 0, 64)
        ENTRY(tables.numDeterm012, 0, 64)


RAND_TABLE("plurDeterm")
        ENTRY(tables.vocPlurDeterm, 0, 127)
        ENTRY(tables.plurNumDeterm, 0, 64)


SEQ_TABLE("plurNounDetermPhrase")
        ENTRY(tables.plurDeterm, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.adjectivePhrase, 0, 16)
        ENTRY(tables.vocPlurNoun, 0, 127)


SEQ_TABLE("plurPropNoun")
        ENTRY(tables.adjectivePhrase, 0, 8)
        ENTRY(tables.vocPlurPropNoun, 0, 127)


SEQ_TABLE("plurNounNodetermPhrase")
        ENTRY(tables.adjectivePhrase, 0, 16)
        ENTRY(tables.vocPlurNounNodeterm, 0, 127)


RAND_TABLE("plurNounPhrase")
        ENTRY(tables.plurNounDetermPhrase, 0, 32)
        ENTRY(tables.plurNounNodetermPhrase, 0, 127)
        ENTRY(tables.plurPropNoun, 0, 16)




--/* Singular noun phrase */

RAND_TABLE("anySingNoun")
        ENTRY(tables.vocSingNounA, 0, 127)
        ENTRY(tables.vocSingNounAn, 0, 127)
        ENTRY(tables.vocSingNounNodeterm, 0, 127)
        ENTRY(tables.vocSingPropNoun, 0, 32)


RAND_TABLE("singNounDeterm")
        ENTRY(tables.vocSingDeterm, 0, 127)
        ENTRY(tables.vocSingDetermNonum, 0, 127)


RAND_TABLE("singNounDetermAn")
        ENTRY(tables.an, 0, 24)
        ENTRY(tables.singNounDeterm, 0, 127)


RAND_TABLE("singNounDetermA")
        ENTRY(tables.a, 0, 24)
        ENTRY(tables.singNounDeterm, 0, 127)


SEQ_TABLE("singNounAnPhrase")
        ENTRY(tables.singNounDetermAn, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocSingNounAn, 0, 127)


SEQ_TABLE("singNounAPhrase")
        ENTRY(tables.singNounDetermA, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocSingNounA, 0, 127)


SEQ_TABLE("singNounNodetermPhrase")
        ENTRY(tables.adjectivePhrase, 0, 32)
        ENTRY(tables.vocSingNounNodeterm, 0, 127)


SEQ_TABLE("singPropNoun")
        ENTRY(tables.adjectivePhrase, 0, 8)
        ENTRY(tables.vocSingPropNoun, 0, 127)


RAND_TABLE("singNounPhrase")
        ENTRY(tables.singNounAPhrase, 0, 127)
        ENTRY(tables.singNounAnPhrase, 0, 127)
        ENTRY(tables.singNounNodetermPhrase, 0, 127)
        ENTRY(tables.singPropNoun, 0, 48)




--/* Noun phrase */

SEQ_TABLE("singNounPhrasePossessive")
        ENTRY(tables.singNounPhrase, 0, 127)
        ENTRY(tables.apostropheS, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.adjectivePhrase, 0, 127)
        ENTRY(tables.anySingNoun, 0, 127)


SEQ_TABLE("plurNounPhrasePossessive")
        ENTRY(tables.plurNounPhrase, 0, 127)
        ENTRY(tables.apostrophe, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.adjectivePhrase, 0, 32)
        ENTRY(tables.anyPlurNoun, 0, 127)


RAND_TABLE("nounPhrase")
        ENTRY(tables.singNounPhrase, 0, 127)
        ENTRY(tables.plurNounPhrase, 0, 127)
        ENTRY(tables.singNounPhrasePossessive, 0, 32)
        ENTRY(tables.plurNounPhrasePossessive, 0, 32)




--/* Verb phrase */

SEQ_TABLE("adverbBefore")
        ENTRY(tables.vocAdverbBefore, 0, 127)
        ENTRY(tables.space, 0, 127)


SEQ_TABLE("adverbAfter")
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocAdverbAfter, 0, 127)


RAND_TABLE("verbObject")
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.me, 0, 32)
        ENTRY(tables.us, 0, 32)


SEQ_TABLE("auxVerbMainPProgTrans")
        ENTRY(tables.vocTransVerbPProg, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.verbObject, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


SEQ_TABLE("intransVerbPProg")
        ENTRY(tables.vocIntransVerbPProg, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


RAND_TABLE("auxVerbMainPProg")
        ENTRY(tables.auxVerbMainPProgTrans, 0, 127)
        ENTRY(tables.vocIntransVerbPProg, 0, 127)


SEQ_TABLE("intransVerbPlur")
        ENTRY(tables.adverbBefore, 0, 127)
        ENTRY(tables.vocIntransVerbPlur, 0, 127)
        ENTRY(tables.adverbAfter, 0, 127)


SEQ_TABLE("transVerbPlur")
        ENTRY(tables.adverbBefore, 0, 32)
        ENTRY(tables.vocTransVerbPlur, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.verbObject, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


SEQ_TABLE("intransVerbSing")
        ENTRY(tables.adverbBefore, 0, 32)
        ENTRY(tables.vocIntransVerbSing, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


SEQ_TABLE("transVerbSing")
        ENTRY(tables.adverbBefore, 0, 32) 
        ENTRY(tables.vocTransVerbSing, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.verbObject, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


SEQ_TABLE("transVerbInf")
        ENTRY(tables.adverbBefore, 0, 32)
        ENTRY(tables.vocTransVerbInf, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.verbObject, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


SEQ_TABLE("intransVerbInf")
        ENTRY(tables.adverbBefore, 0, 32)
        ENTRY(tables.vocTransVerbInf, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


RAND_TABLE("infVerbPhrase")
        ENTRY(tables.vocIntransVerbInf, 0, 127)
        ENTRY(tables.transVerbInf, 0, 127)


SEQ_TABLE("singAuxVerbPhraseInf")
        ENTRY(tables.vocAuxVerbInf, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.infVerbPhrase, 0, 127)


SEQ_TABLE("singAuxVerbPhrasePProg")
        ENTRY(tables.vocSingAuxVerbPProg, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.auxVerbMainPProg, 0, 127)


RAND_TABLE("singAuxVerbPhrase")
        ENTRY(tables.singAuxVerbPhraseInf, 0, 127)
        ENTRY(tables.singAuxVerbPhrasePProg, 0, 127)


SEQ_TABLE("isNoun")
        ENTRY(tables.is, 0, 127)
        ENTRY(tables.nounPhrase, 0, 127)


SEQ_TABLE("isAdjective")
        ENTRY(tables.is, 0, 127)
        ENTRY(tables.doAdjectivePhrase, 0, 127)


RAND_TABLE("singVerbPhrase")
        ENTRY(tables.intransVerbSing, 0, 127)
        ENTRY(tables.transVerbSing, 0, 64)
        ENTRY(tables.singAuxVerbPhrase, 0, 32)
        ENTRY(tables.isNoun, 0, 127)
        ENTRY(tables.isAdjective, 0, 127)


SEQ_TABLE("singNounVerbPhrase")
        ENTRY(tables.singNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.singVerbPhrase, 0, 127)


SEQ_TABLE("plurNounVerbPhrase")
        ENTRY(tables.plurNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.plurVerbPhrase, 0, 127)


SEQ_TABLE("twoNounAnd")
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocNounListAndConjunction, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables["plurVerbPhrase"], 0, 127)


SEQ_TABLE("twoNounOrSing")
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocNounListOrConjunction, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.singNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.singVerbPhrase, 0, 127)


SEQ_TABLE("plurAuxVerbPhraseInf")
        ENTRY(tables.vocAuxVerbInf, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.infVerbPhrase, 0, 127)


SEQ_TABLE("plurAuxVerbPhrasePProg")
        ENTRY(tables.vocPlurAuxVerbPProg, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.auxVerbMainPProg, 0, 127)


RAND_TABLE("plurAuxVerbPhrase")
        ENTRY(tables.plurAuxVerbPhraseInf, 0, 127)
        ENTRY(tables.plurAuxVerbPhrasePProg, 0, 127)


SEQ_TABLE("areNoun")
        ENTRY(tables.are, 0, 127)
        ENTRY(tables.nounPhrase, 0, 127)


SEQ_TABLE("areAdjective")
        ENTRY(tables.are, 0, 127)
        ENTRY(tables.doAdjectivePhrase, 0, 127)


RAND_TABLE("plurVerbPhrase")
        ENTRY(tables.vocIntransVerbPlur, 0, 127)
        ENTRY(tables.transVerbPlur, 0, 127)
        ENTRY(tables.plurAuxVerbPhrase, 0, 127)
        ENTRY(tables.areAdjective, 0, 127)
        ENTRY(tables.areNoun, 0, 127)


SEQ_TABLE("twoNounOrPlur")
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocNounListOrConjunction, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.plurNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.plurVerbPhrase, 0, 127)


RAND_TABLE("twoNounVerbPhrase")
        ENTRY(tables.twoNounAnd, 0, 127)
        ENTRY(tables.twoNounOrSing, 0, 127)
        ENTRY(tables.twoNounOrPlur, 0, 127)


SEQ_TABLE("threeNounVerbPhrase")
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.comma, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.twoNounVerbPhrase, 0, 127)


RAND_TABLE("iAmNounAdjectiveOrVerb")
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.doAdjectivePhrase, 0, 127)
        ENTRY(tables.auxVerbMainPProg, 0, 127)


SEQ_TABLE("iAm")
        ENTRY(tables.am, 0, 127)
        ENTRY(tables.iAmNounAdjectiveOrVerb, 0, 127)


SEQ_TABLE("myselfVerb")
        ENTRY(tables.adverbBefore, 0, 32)
        ENTRY(tables.vocTransVerbPlur, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.myself, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


RAND_TABLE("iNormalVerbPhrase")
        ENTRY(tables.vocIntransVerbPlur, 0, 127)
        ENTRY(tables.transVerbPlur, 0, 127)
        ENTRY(tables.myselfVerb, 0, 127)
        ENTRY(tables.plurAuxVerbPhrase, 0, 127)


SEQ_TABLE("spaceINormalVerbPhrase")
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.iNormalVerbPhrase, 0, 127)


RAND_TABLE("iVerb")
        ENTRY(tables.spaceINormalVerbPhrase, 0, 127)
        ENTRY(tables.iAm, 0, 64)


SEQ_TABLE("iVerbPhrase")
        ENTRY(tables.I, 0, 127)
        ENTRY(tables.iVerb, 0, 127)


SEQ_TABLE("youVerbPhrase")
        ENTRY(tables.you, 0, 127)
        ENTRY(tables.plurVerbPhrase, 0, 127)


RAND_TABLE("nounVerbPhrase")
        ENTRY(tables.singNounVerbPhrase, 0, 127)
        ENTRY(tables.plurNounVerbPhrase, 0, 127)
        ENTRY(tables.twoNounVerbPhrase, 0, 16)
        ENTRY(tables.threeNounVerbPhrase, 0, 16)
        ENTRY(tables.iVerbPhrase, 0, 32)
        ENTRY(tables.youVerbPhrase, 0, 32)




--/* Imperatives */

SEQ_TABLE("impYourselfVerbPhrase")
        ENTRY(tables.adverbBefore, 0, 32)
        ENTRY(tables.vocTransVerbInf, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.yourself, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


RAND_TABLE("impAuxVerbPhrase")
        ENTRY(tables.infVerbPhrase, 0, 127)
        ENTRY(tables.plurAuxVerbPhrasePProg, 0, 127)


RAND_TABLE("impVerbPhrase")
        ENTRY(tables.impAuxVerbPhrase, 0, 127)
        ENTRY(tables.impYourselfVerbPhrase, 0, 127)


SEQ_TABLE("impAuxVerb")
        ENTRY(tables.vocImpAuxVerb, 0, 127)
        ENTRY(tables.space, 0, 127)


SEQ_TABLE("imperativeSentence")
        ENTRY(tables.address, 0, 16)
        ENTRY(tables.impAuxVerb, 0, 64)
        ENTRY(tables.impVerbPhrase, 0, 127)
        ENTRY(tables.punct, 0, 127)




--/* Interrogatives */

RAND_TABLE("interNounOrAdjective")
        ENTRY(tables.nounPhrase, 0, 127)
        ENTRY(tables.doAdjectivePhrase, 0, 127)


SEQ_TABLE("interSingVerbPhraseNormal")
        ENTRY(tables.vocInterSingAuxVerb, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.singNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.infVerbPhrase, 0, 127)


SEQ_TABLE("interSingIsNounOrAdjective")
        ENTRY(tables.is, 0, 127)
        ENTRY(tables.singNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.interNounOrAdjective, 0, 127)


RAND_TABLE("interSingVerbPhrase")
        ENTRY(tables.interSingVerbPhraseNormal, 0, 127)
        ENTRY(tables.interSingIsNounOrAdjective ,0 ,63)


SEQ_TABLE("interPlurVerbPhraseNormal")
        ENTRY(tables.vocInterPlurAuxVerb, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.plurNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.infVerbPhrase, 0, 127)


SEQ_TABLE("interPlurAreNounOrAdjective")
        ENTRY(tables.are, 0, 127)
        ENTRY(tables.plurNounPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.interNounOrAdjective, 0, 127)


RAND_TABLE("interPlurVerbPhrase")
        ENTRY(tables.interPlurVerbPhraseNormal, 0, 127)
        ENTRY(tables.interPlurAreNounOrAdjective ,0 ,63)


RAND_TABLE("interVerbPhrase")
        ENTRY(tables.interSingVerbPhrase, 0, 127)
        ENTRY(tables.interPlurVerbPhrase, 0, 127)


SEQ_TABLE("intPronounSingSubject")
        ENTRY(tables.vocInterSingAuxVerb, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.singNounPhrase, 0, 127)


SEQ_TABLE("intPronounPlurSubject")
        ENTRY(tables.vocInterPlurAuxVerb, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.plurNounPhrase, 0, 127)


RAND_TABLE("intPronounSubject")
        ENTRY(tables.intPronounSingSubject, 0, 127)
        ENTRY(tables.intPronounPlurSubject, 0, 127)


SEQ_TABLE("intPronounVerbPhrase")
        ENTRY(tables.intPronounSubject, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.adverbBefore, 0, 32)
        ENTRY(tables.vocTransVerbInf, 0, 127)
        ENTRY(tables.adverbAfter, 0, 32)


SEQ_TABLE("whoWhatPhrase")
        ENTRY(tables.whoWhat, 0, 127)
        ENTRY(tables.intPronounVerbPhrase, 0, 127)
        ENTRY(tables.punct, 0, 127)


SEQ_TABLE("howManyPhrase")
        ENTRY(tables.howMany, 0, 127)
        ENTRY(tables.anyPlurNoun, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.intPronounVerbPhrase, 0, 127)
        ENTRY(tables.punct, 0, 127)


SEQ_TABLE("whichPhrase")
        ENTRY(tables.which, 0, 127)
        ENTRY(tables.anySingNoun, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.intPronounVerbPhrase, 0, 127)
        ENTRY(tables.punct, 0, 127)


SEQ_TABLE("whenWhereWhyHowPhrase")
        ENTRY(tables.whenWhereWhyHow, 0, 127)
        ENTRY(tables.intBooleanPhrase, 0, 127)


RAND_TABLE("intPronounPhrase")
        ENTRY(tables.whoWhatPhrase, 0, 127)
        ENTRY(tables.howManyPhrase, 0, 127)
        ENTRY(tables.whichPhrase, 0, 127)
        ENTRY(tables.whenWhereWhyHowPhrase, 0, 127)


SEQ_TABLE("intBooleanPhrase")
        ENTRY(tables.interVerbPhrase, 0, 127)
        ENTRY(tables.punct, 0, 127)


RAND_TABLE("interrogativeSentence")
        ENTRY(tables.intPronounPhrase, 0, 127)
        ENTRY(tables.intBooleanPhrase, 0, 127)




--/* Root and high-level definitions */

SEQ_TABLE("intro")
        ENTRY(tables.vocIntroPhrase, 0, 127)
        ENTRY(tables.space, 0, 127)


SEQ_TABLE("conjoinedSentence")
        ENTRY(tables.comma, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.vocSentenceConjunction, 0, 127)
        ENTRY(tables.space, 0, 127)
        ENTRY(tables.nounVerbPhrase, 0, 127)
        ENTRY(tables.conjoinedSentence, 0, 8)


RAND_TABLE("addressNoun")
        ENTRY(tables.vocSingPropNoun, 0, 127)
        ENTRY(tables.vocSingNounA, 0, 2)
        ENTRY(tables.vocSingNounAn, 0, 2)
        ENTRY(tables.vocSingNounNodeterm, 0, 2)
        ENTRY(tables.vocPlurNoun, 0, 2)
        ENTRY(tables.vocPlurNounNodeterm, 0, 2)


SEQ_TABLE("address")
        ENTRY(tables.addressNoun, 0, 127)
        ENTRY(tables.comma, 0, 127)
        ENTRY(tables.space, 0, 127)


SEQ_TABLE("declaratorySentence")
        ENTRY(tables.intro, 0, 16)
        ENTRY(tables.address, 0, 16)
        ENTRY(tables.nounVerbPhrase, 0, 127)
        ENTRY(tables.conjoinedSentence, 0, 32)
        ENTRY(tables.punct, 0, 127)


RAND_TABLE("mainSentence")
        ENTRY(tables.declaratorySentence, 0, 127)
        ENTRY(tables.imperativeSentence, 0, 64)
        ENTRY(tables.interrogativeSentence, 0, 16)


SEQ_TABLE("interjection")
        ENTRY(tables.vocInterjection, 0, 127)
        ENTRY(tables.punct, 0, 127)


SEQ_TABLE("interjectionOnly")
        ENTRY(tables.interjection, 1, 127)
        ENTRY(tables.interjection, 1, 16)
        ENTRY(tables.interjection, 1, 4)
        ENTRY(tables.interjection, 1, 8)


SEQ_TABLE("normal")
        ENTRY(tables.interjection, 1, 16)
        ENTRY(tables.interjection, 1, 16)
        ENTRY(tables.interjection, 1, 4)
        ENTRY(tables.mainSentence, 1, 127)
        ENTRY(tables.interjection, 1, 32)


RAND_TABLE("rootTable")
        ENTRY(tables.interjectionOnly, 0, 4)
        ENTRY(tables.normal, 0, 127)

